routes/web.php
<?php

use App\Http\Controllers\AuthCtrl;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\UserController;
use App\Http\Controllers\NilaiController;
use App\Http\Controllers\BeasiswaController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\MahasiswaController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::group(["middleware"=>"auth"],function(){
    Route::get('/', [DashboardController::class,'index'])->name("home");
    
    Route::group(["middleware"=>"roleAdmin"],function(){
        Route::resource('mahasiswa',MahasiswaController::class);
        Route::resource('nilai',NilaiController::class);
        Route::resource('users',UserController::class);
        Route::resource('beasiswa',BeasiswaController::class);
        Route::get('beasiswa/{id}/{status}/update',[BeasiswaController::class,'update_status'])->name("update_status");
    });

    Route::group(["middleware"=>"roleMahasiswa"],function(){
        Route::resource('beasiswa',BeasiswaController::class);
    });

    Route::get('logout',[AuthCtrl::class,'logout'])->name("auth.logout");

});

// Route Login
Route::get('login',[AuthCtrl::class,'login'])->name("auth.login");
Route::post('ceklogin',[AuthCtrl::class,'cek_login'])->name("auth.check");

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    public $guarded = ["id"];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
        'password' => 'hashed',
    ];
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;

class UserController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public $title = "User";
    public function index()
    {
        $data = [
            "title" => "Data ".$this->title,
            "page_name" => "Data ".$this->title,
            "dtUser" => User::All()
        ];

        return view("user.data",$data);
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        $data = [
            "title" => "Data ".$this->title,
            "page_name" => "Add ".$this->title,
            "is_edit" => false
        ];

        return view("user.form",$data);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        try {            
    
            User::create([
                "name"=>$request->input("name"),
                "email"=>$request->input("email"),
                "password"=>Hash::make($request->input("password")),
                "role"=>$request->input("role"),
                "id_reff"=>$request->input("id_reff"),
                "status"=>$request->input("status")
            ]);
   
            // Message
            $mess = [
                "type" => "success",
                "text" => "Data Berhasil Disimpan !"
            ];

            return redirect(route("users.index"))->with($mess);

        } catch(Exception $err){
            $mess = [
                "type" => "danger",
                "text" => "Data Gagal Disimpan !<br/>".$err->getMessage()
            ];
            return redirect(route("users.index"))->with($mess);
        }
    }

    /**
     * Display the specified resource.
     */
    public function show(User $user)
    {

    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(User $user)
    {
        $data = [
            "title" => "Data ".$this->title,
            "page_name" => "Add ".$this->title,
            "rsUser" => $user,
            "is_edit" => true
        ];

        return view("user.form",$data);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, User $user)
    {
        try {            
    
            User::where("id",$user->id)->update([
                "name"=>$request->input("name"),
                "email"=>$request->input("email"),
                "password"=>$request->input("password") !="" ? Hash::make($request->input("password")) : $request->input("old_password"),
                "role"=>$request->input("role"),
                "id_reff"=>$request->input("id_reff"),
                "status"=>$request->input("status")
            ]);
   
            // Message
            $mess = [
                "type" => "success",
                "text" => "Data Berhasil di Update !"
            ];

            return redirect(route("users.index"))->with($mess);

        } catch(Exception $err){
            $mess = [
                "type" => "danger",
                "text" => "Data Gagal di Update !<br/>".$err->getMessage()
            ];
            return redirect(route("users.index"))->with($mess);
        }
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(User $user)
    {
        try {            
    
            User::where("id",$user->id)->delete();
   
            // Message
            $mess = [
                "type" => "success",
                "text" => "Data Berhasil di Hapus !"
            ];

            return redirect(route("mahasiswa.index"))->with($mess);

        } catch(Exception $err){
            $mess = [
                "type" => "danger",
                "text" => "Data Gagal di Hapus !<br/>".$err->getMessage()
            ];
            return redirect(route("mahasiswa.index"))->with($mess);
        }
    }
}

resources/views/user/data.blade.php
@extends('layouts.base')

@section('title',$title)
@section('page_name',$title)

@section("content")
<div class="card">
    <div class="card-header">
        <div class="card-tools">
            <a href="{{ route("users.create") }}" class="btn btn-primary btn-xs"><i class="fas fa-plus"></i> ADD NEW</a>
        </div> 
    </div>
    <div class="card-body">
        <table class="data table table-bordered table-striped">
            <thead>
                <tr>
                    <th>NAMA</th>
                    <th>EMAIL</th>
                    <th>ROLE</th>
                    <th>STATUS</th>
                    <th>ACTION</th>
                </tr>
            </thead>
            <tbody>
                @foreach ($dtUser as $rsUser)                
                    <tr>
                        <td>{{ $rsUser->name}}</td>
                        <td>{{ $rsUser->email}}</td>
                        <td>{{ $rsUser->role }}</td>
                        <td>
                            <span class="badge bg-{{ $rsUser->status==1 ? "success" : "danger" }}">{{ $rsUser->status==1 ? "Aktif" : "Non Aktif" }}</span>
                        </td>
                        <td class="text-center">
                            <a class="btn btn-warning btn-xs" href="{{ route('users.edit',$rsUser->id) }}"><i class="fas fa-edit"></i></a>
                            <form class="d-inline" action="{{ route("users.destroy",$rsUser->id) }}" method="post">
                                @method("DELETE")
                                <button type="submit" class="btn btn-danger btn-xs"><i class="fas fa-times"></i></button>
                            </form>
                        </td>
                    </tr>
                @endforeach
            </tbody>
        </table>            
    </div>
</div>   
@endsection

resources/views/user/form.blade.php
@extends('layouts.base')

@section('title',$title)
@section('page_name',$title)
    
@section('content')
    <div class="row">
        <div class="col-md-7 mx-auto">
          {{-- Notification --}}
            @if ($errors->any())
              <div class="alert alert-danger alert-dismissible">
                <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                <h5><i class="icon fas fa-check"></i> Error</h5>
                Terjadi Kesalahan , silahkan periksa kembali inputan anda
              </div>
            @endif
            <div class="card">
                <div class="card-header">
                    <div class="card-title">
                        {{ $page_name }}
                    </div>
                </div>
                <div class="card-body">
                    <form action="{{ $is_edit ? route("users.update",@$rsUser->id) : route("users.store") }}" method="post">
                        @csrf
                        @if ($is_edit)
                          @method("PUT")
                        @endif                                                                      
                        <div class="mb-3">
                          <label for="name" class="form-label">Nama</label>
                          <input type="text" name="name" id="name" class="form-control @error('name') is-invalid @enderror" value="{{ @old("name")!="" ? @old("name") : @$rsUser->name }}">
                          @error("name")
                            <div id="valname" class="invalid-feedback">
                              {{ $message }}
                            </div>
                          @enderror
                        </div>
                        <div class="mb-3">
                          <label for="email" class="form-label">Email</label>
                          <input type="text" name="email" id="email" class="form-control @error('email') is-invalid @enderror" value="{{ @old("email")!="" ? @old("email") : @$rsUser->email }}">
                          @error("email")
                            <div id="valemail" class="invalid-feedback">
                              {{ $message }}
                            </div>
                          @enderror
                        </div>                                   
                        <div class="mb-3">
                          <label for="password" class="form-label">Password</label>
                          <input type="password" name="password" id="password" class="form-control @error('password') is-invalid @enderror" value="{{ @old("password") }}">
                          <input type="hidden" name="old_password" id="old_password" value="{{ @$rsUser->password }}">
                          @error("password")
                            <div id="valpassword" class="invalid-feedback">
                              {{ $message }}
                            </div>
                          @enderror
                        </div>
                        <div class="mb-3">
                          <label for="id_reff" class="form-label">ID Reff ( NIM / NIK )</label>
                          <input type="text" name="id_reff" id="id_reff" class="form-control @error('id_reff') is-invalid @enderror" value="{{ @old("id_reff")!="" ? @old("id_reff") : @$rsUser->id_reff }}">
                          @error("id_reff")
                            <div id="valid_reff" class="invalid-feedback">
                              {{ $message }}
                            </div>
                          @enderror
                        </div>                               
                        <div class="mb-3">
                          <label for="role" class="form-label">Role</label>
                          <select name="role" id="role" class="form-control @error('role') is-invalid @enderror">
                            <option {{ (@old("role") == "Admin" ? "selected" : (@$rsUser->role == "Admin" ? "selected" : "" )) }} value="Admin">Admin</option>
                            <option {{ (@old("role") == "Mahasiswa" ? "selected" : (@$rsUser->role == "Mahasiswa" ? "selected" : "" )) }} value="Mahasiswa">Mahasiswa</option>
                          </select>
                          @error("role")
                          <div id="valrole" class="invalid-feedback">
                            {{ $message }}
                          </div>
                          @enderror
                      </div>      
                      <div class="mb-3">
                          <label for="status" class="form-label">Status</label>
                          <select name="status" id="status" class="form-control @error('status') is-invalid @enderror">                              
                            <option {{ (@old("status") == 1 ? "selected" : (@$rsUser->status == 1 ? "selected" : "")) }} value="1">Aktif</option>
                            <option {{ (@old("status") == 2 ? "selected" : (@$rsUser->status == 2 ? "selected" : "")) }} value="2">Non Aktif</option>
                          </select>
                          @error("status")
                          <div id="valstatus" class="invalid-feedback">
                            {{ $message }}
                          </div>
                          @enderror
                      </div>                                                  
                        <div class="mb-3">
                            <input type="submit" value="SIMPAN" class="btn btn-primary btn-md">
                        </div>        
                        <div id="complete"></div>
                    </form>
                </div>
            </div>
        </div>
    </div>
@endsection